

```julia
using TuringModels

Turing.setadbackend(:reverse_diff);
Turing.turnprogress(false);
```

    ┌ Info: Recompiling stale cache file /Users/rob/.julia/compiled/v1.2/TuringModels/nq4gQ.ji for TuringModels [ead7e11d-4ba5-55c3-9d74-177ea73ef1fd]
    └ @ Base loading.jl:1188


    loaded


    ┌ Info: [Turing]: global PROGRESS is set as false
    └ @ Turing /Users/rob/.julia/packages/Turing/r03H1/src/Turing.jl:24


Can't really set a Uniform[-Inf,Inf] on σ

Turing model


```julia
@model m8_4(y) = begin
    α₁ ~ Uniform(-3000, 1000)
    α₂ ~ Uniform(-1000, 3000)
    σ ~ Truncated(Cauchy(0,1), 0, Inf)

    for i ∈ 1:length(y)
        y[i] ~ Normal(α₁ + α₂, σ)
    end
end
```




    m8_4 (generic function with 2 methods)



Observations


```julia
y = rand(Normal(0,1), 100);
```

Sample


```julia
posterior = sample(m8_4(y), Turing.NUTS(4000, 1000, 0.95));
```

    ┌ Info: [Turing] looking for good initial eps...
    └ @ Turing.Inference /Users/rob/.julia/packages/Turing/r03H1/src/inference/support/hmc_core.jl:240
    ┌ Warning: Numerical error has been found in gradients.
    └ @ Turing.Core /Users/rob/.julia/packages/Turing/r03H1/src/core/ad.jl:169
    ┌ Warning: grad = [NaN, NaN, NaN]
    └ @ Turing.Core /Users/rob/.julia/packages/Turing/r03H1/src/core/ad.jl:170
    ┌ Warning: Numerical error has been found in gradients.
    └ @ Turing.Core /Users/rob/.julia/packages/Turing/r03H1/src/core/ad.jl:169
    ┌ Warning: grad = [NaN, NaN, NaN]
    └ @ Turing.Core /Users/rob/.julia/packages/Turing/r03H1/src/core/ad.jl:170
    ┌ Warning: Numerical error has been found in gradients.
    └ @ Turing.Core /Users/rob/.julia/packages/Turing/r03H1/src/core/ad.jl:169
    ┌ Warning: grad = [NaN, NaN, NaN]
    └ @ Turing.Core /Users/rob/.julia/packages/Turing/r03H1/src/core/ad.jl:170
    ┌ Warning: Numerical error has been found in gradients.
    └ @ Turing.Core /Users/rob/.julia/packages/Turing/r03H1/src/core/ad.jl:169
    ┌ Warning: grad = [NaN, NaN, NaN]
    └ @ Turing.Core /Users/rob/.julia/packages/Turing/r03H1/src/core/ad.jl:170
    ┌ Warning: Numerical error has been found in gradients.
    └ @ Turing.Core /Users/rob/.julia/packages/Turing/r03H1/src/core/ad.jl:169
    ┌ Warning: grad = [NaN, NaN, NaN]
    └ @ Turing.Core /Users/rob/.julia/packages/Turing/r03H1/src/core/ad.jl:170
    ┌ Warning: Numerical error has been found in gradients.
    └ @ Turing.Core /Users/rob/.julia/packages/Turing/r03H1/src/core/ad.jl:169
    ┌ Warning: grad = [NaN, NaN, -99.0000000000002]
    └ @ Turing.Core /Users/rob/.julia/packages/Turing/r03H1/src/core/ad.jl:170
    [NUTS{Turing.Core.FluxTrackerAD,Union{}}] found initial ϵ: 0.0015625
    └ @ Turing.Inference /Users/rob/.julia/packages/Turing/r03H1/src/inference/support/hmc_core.jl:235
    ┌ Info:  Adapted ϵ = 0.0012446019552466972, std = [1.0, 1.0, 1.0]; 1000 iterations is used for adaption.
    └ @ Turing.Inference /Users/rob/.julia/packages/Turing/r03H1/src/inference/adapt/adapt.jl:91


    [NUTS] Finished with
      Running time        = 503.2693889070004;
      #lf / sample        = 0.0;
      #evals / sample     = 131.66425;
      pre-cond. metric    = [1.0, 1.0, 1.0].


Fix the inclusion of adaptation samples


```julia
draws = 1001:4000
posterior2 = Chains(posterior[draws,:,:], :parameters)
```




    Object of type Chains, with data of type 3000×3×1 Array{Union{Missing, Float64},3}
    
    Log evidence      = 0.0
    Iterations        = 1001:4000
    Thinning interval = 1
    Chains            = Chain1
    Samples per chain = 3000
    parameters        = α₂, α₁, σ
    
    parameters
          Mean      SD   Naive SE  MCSE     ESS  
    α₁  910.8323 21.9943   0.4016 3.7948  33.5924
    α₂ -910.6959 21.9930   0.4015 3.7947  33.5911
     σ    1.0401  0.0744   0.0014 0.0069 117.3083
    




Describe the posterior samples


```julia
describe(posterior2)
```

    Log evidence      = 0.0
    Iterations        = 1001:4000
    Thinning interval = 1
    Chains            = Chain1
    Samples per chain = 3000
    parameters        = α₂, α₁, σ
    


    ┌ Warning: `quantile(v::AbstractArray{<:Real})` is deprecated, use `quantile(v, [0.0, 0.25, 0.5, 0.75, 1.0])` instead.
    │   caller = (::getfield(MCMCChains, Symbol("##102#104")){Chains{Union{Missing, Float64},Float64,NamedTuple{(:parameters,),Tuple{Array{String,1}}},NamedTuple{(:hashedsummary,),Tuple{Base.RefValue{Tuple{UInt64,MCMCChains.ChainSummaries}}}}}})(::String) at none:0
    └ @ MCMCChains ./none:0


    [36m[1mEmpirical Posterior Estimates[22m[39m
    ────────────────────────────────────────────────────
    parameters
          Mean      SD   Naive SE  MCSE     ESS  
    α₁  910.8323 21.9943   0.4016 3.7948  33.5924
    α₂ -910.6959 21.9930   0.4015 3.7947  33.5911
     σ    1.0401  0.0744   0.0014 0.0069 117.3083
    
    [36m[1mQuantiles[22m[39m
    ────────────────────────────────────────────────────
    parameters
          2.5%     25.0%     50.0%     75.0%     97.5%  
    α₁  859.3251  890.0703  914.4814  929.4525  959.2620
    α₂ -958.9285 -929.3161 -914.3284 -890.0230 -859.1671
     σ    0.8119    0.9883    1.0315    1.0811    1.3478
    


Results rethinking


```julia
m84rethinking = "
         mean      sd     5.5%   94.5% n_eff Rhat
 a1    -861.15 558.17 -1841.89  -31.04     7 1.43
 a2     861.26 558.17    31.31 1842.00     7 1.43
 sigma    0.97   0.07     0.89    1.09     9 1.17
";
```

*This notebook was generated using [Literate.jl](https://github.com/fredrikekre/Literate.jl).*
